package parte01;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import java.util.HashSet;
import java.util.Set;

import javax.swing.JFrame;
import javax.swing.JPanel;

public class MainJFramePainelJava2D {
	public static void main(String[] args) {
		JanelaTestePainelJava2D janela = new JanelaTestePainelJava2D("Minha primeira janela");
		janela.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		janela.setSize(400, 300);
		janela.setVisible(true);
	}
}

class JanelaTestePainelJava2D extends JFrame {
	public JanelaTestePainelJava2D(String titulo) {
		super(titulo);
		initComponents();
	}

	private void initComponents() {
		/*
		setLayout(null);

		JPanel painelAzul = new JPanel();
		painelAzul.setBackground(Color.BLUE);
		add(painelAzul);
		painelAzul.setBounds(100, 50, 200, 50);
		*/
		
		final PainelDesenho painel = new PainelDesenho();
		setContentPane(painel);
		
		addKeyListener(new KeyAdapter() {
			public void keyReleased(KeyEvent e) {
				
				if (e.getKeyCode() == KeyEvent.VK_L) {
					if ((e.getModifiers() & KeyEvent.CTRL_MASK) > 0)
						painel.limpar();
				}
			}
		});
	}
}

class PainelDesenho extends JPanel {
	private Set<Point> pontos = new HashSet<Point>();
	
	public PainelDesenho() {
		initComponents();
	}
	
	private void initComponents() {
		addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				pontos.add(e.getPoint());
				repaint();
			}
		});
		
		addMouseMotionListener(new MouseMotionAdapter() {
			public void mouseDragged(MouseEvent e) {
				pontos.add(e.getPoint());
				repaint();
			}
		});
	}

	protected void paintComponent(Graphics g) {
		super.paintComponent(g);	// Essencial!
		for (Point p : pontos) g.fillOval(p.x, p.y, 10, 10);
	}
	
	public void limpar() {
		pontos.clear();
		repaint();
	}
}