package parte01;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Map;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

public class MainTesteCampoSenha {
	public static void main(String[] args) {
		JanelaTesteCamposSenha janela = new JanelaTesteCamposSenha("Login");
		janela.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		janela.setSize(200, 180);
		janela.setVisible(true);
	}
}

class JanelaTesteCamposSenha extends JFrame {
	private JTextField textoLogin;
	private JPasswordField textoSenha;
	
	private static Map<String, char[]> usuarios = new HashMap<String, char[]>();
	static {
		usuarios.put("fulano", new char[] {'f', 'u', 'l', '3', '5' });
		usuarios.put("beltrano", new char[] {'t', 'r', 'a', 'n', '4', '0'});
		usuarios.put("admin", new char[] {'s', 'a', '1', '0', '0', '0'});
	}
	
	public JanelaTesteCamposSenha(String titulo) {
		super(titulo);
		initComponents();
	}

	private void initComponents() {
		setLayout(new FlowLayout());
		setResizable(false);
		
		// Rótulo do login:
		JLabel rotuloLogin = new JLabel("Login: ");
		rotuloLogin.setHorizontalAlignment(JLabel.RIGHT);
		rotuloLogin.setPreferredSize(new Dimension(100, 30));
		add(rotuloLogin);
		
		// Campo texto do login:
		textoLogin = new JTextField();
		textoLogin.setPreferredSize(new Dimension(100, 20));
		add(textoLogin);
		
		// Rótulo da senha:
		JLabel rotuloSenha = new JLabel("Senha: ");
		rotuloSenha.setHorizontalAlignment(JLabel.RIGHT);
		rotuloSenha.setPreferredSize(new Dimension(100, 30));
		add(rotuloSenha);
		
		// Campo senha:
		textoSenha = new JPasswordField();
		textoSenha.setPreferredSize(new Dimension(100, 20));
		add(textoSenha);
		
		// Registra o ouvinte.
		LoginListener listener = new LoginListener();
		textoLogin.addActionListener(listener);
		textoSenha.addActionListener(listener);
	}
	
	private class LoginListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == textoLogin) {
				JOptionPane.showMessageDialog(null, "Você já preencheu a senha?", "Atenção!", JOptionPane.QUESTION_MESSAGE);
			}
			
			String login = textoLogin.getText();
			char[] senha = textoSenha.getPassword();
			
			char[] senhaUsuario = usuarios.get(login);
			if ((senhaUsuario != null) && (senhaIgual(senha, senhaUsuario)))
				JOptionPane.showMessageDialog(null, "Usuário autenticado com sucesso!");
			else
				JOptionPane.showMessageDialog(null, "Login/senha inválidos.");
		}
		
		private boolean senhaIgual(char[] s1, char[] s2) {
			boolean igual = s1.length == s2.length;
			for (int i = 0; igual && (i < s1.length); i++) igual = s1[i] == s2[i];
			return igual;
		}
	}
}
