package parte01;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

public class MainTesteCamposTexto {
	public static void main(String[] args) {
		JanelaTesteCamposTexto janela = new JanelaTesteCamposTexto("Calculadora Java");
		janela.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		janela.setSize(400, 300);
		janela.setVisible(true);
	}
}

class JanelaTesteCamposTexto extends JFrame {
	private JTextField textoNum1;
	private JTextField textoNum2;
	private JTextField textoMdc;
	
	public JanelaTesteCamposTexto(String titulo) {
		super(titulo);
		initComponents();
	}

	private void initComponents() {
		setLayout(new FlowLayout());
		setResizable(false);
		setUndecorated(false);
		setAlwaysOnTop(false);
		setBounds(100, 50, 400, 30);
		
		// Título da janela:
		Icon iconeJar = new ImageIcon(getClass().getResource("/resources/images/iconJar.png"));
		JLabel rotuloTitulo = new JLabel("Calculadora Java", iconeJar, SwingConstants.CENTER);
		rotuloTitulo.setHorizontalTextPosition(JLabel.CENTER);
		rotuloTitulo.setVerticalTextPosition(JLabel.BOTTOM);
		rotuloTitulo.setPreferredSize(new Dimension(380, 100));
		add(rotuloTitulo);
		
		// Rótulo do campo do primeiro número:
		JLabel rotuloNum1 = new JLabel("Primeiro número: ");
		rotuloNum1.setHorizontalAlignment(JLabel.RIGHT);
		rotuloNum1.setPreferredSize(new Dimension(200, 30));
		add(rotuloNum1);
		
		// Campo do primeiro número:
		textoNum1 = new JTextField("1");
		textoNum1.setHorizontalAlignment(JTextField.RIGHT);
		textoNum1.setPreferredSize(new Dimension(180, 20));
		add(textoNum1);
		
		// Rótulo do campo do segundo número:
		JLabel rotuloNum2 = new JLabel("Segundo número: ");
		rotuloNum2.setHorizontalAlignment(JLabel.RIGHT);
		rotuloNum2.setPreferredSize(new Dimension(200, 30));
		add(rotuloNum2);
		
		// Campo do segundo número:
		textoNum2 = new JTextField("1");
		textoNum2.setHorizontalAlignment(JTextField.RIGHT);
		textoNum2.setPreferredSize(new Dimension(180, 20));
		add(textoNum2);
		
		// Rótulo do campo do resultado:
		Icon iconeMat = new ImageIcon(getClass().getResource("/resources/images/iconMath.png"));
		JLabel rotuloMdc = new JLabel("MDC = ");
		rotuloMdc.setIcon(iconeMat);
		rotuloMdc.setHorizontalAlignment(JLabel.RIGHT);
		rotuloMdc.setPreferredSize(new Dimension(200, 50));
		add(rotuloMdc);
		
		// Campo do resultado:
		textoMdc = new JTextField("1");
		textoMdc.setHorizontalAlignment(JTextField.RIGHT);
		textoMdc.setPreferredSize(new Dimension(180, 20));
		textoMdc.setEditable(false);
		add(textoMdc);
		
		// Registra os ouvintes:
		CalculadoraListener listener = new CalculadoraListener();
		textoNum1.addActionListener(listener);
		textoNum2.addActionListener(listener);
	}
	
	private class CalculadoraListener implements ActionListener {
		private Calculadora calc = new Calculadora(); 
		public void actionPerformed(ActionEvent e) {
			String xs = textoNum1.getText();
			String ys = textoNum2.getText();
			
			int x = Integer.parseInt(xs);
			int y = Integer.parseInt(ys);
			int mdc = calc.mdc(x, y);
			
			textoMdc.setText("" + mdc);
		}
	}
}