package parte01;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JToggleButton;
import javax.swing.SwingConstants;

public class MainTesteCheckbox {
	public static void main(String[] args) {
		JanelaTesteCheckbox janela = new JanelaTesteCheckbox("Calculadora Java");
		janela.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		janela.setSize(400, 360);
		janela.setVisible(true);
	}
}

class JanelaTesteCheckbox extends JFrame {
	private JTextField textoNum1;
	private JTextField textoNum2;
	private JTextField textoMdc;
	private JToggleButton botaoTravar;
	private JCheckBox checkboxNegrito;
	private JCheckBox checkboxItalico;
	
	public JanelaTesteCheckbox(String titulo) {
		super(titulo);
		initComponents();
	}

	private void initComponents() {
		setLayout(new FlowLayout());
		setResizable(false);
		
		// Título da janela:
		Icon iconeJar = new ImageIcon(getClass().getResource("/resources/images/iconJar.png"));
		JLabel rotuloTitulo = new JLabel("Calculadora Java", iconeJar, SwingConstants.CENTER);
		rotuloTitulo.setHorizontalTextPosition(JLabel.CENTER);
		rotuloTitulo.setVerticalTextPosition(JLabel.BOTTOM);
		rotuloTitulo.setPreferredSize(new Dimension(380, 100));
		add(rotuloTitulo);
		
		// Rótulo do campo do primeiro número:
		JLabel rotuloNum1 = new JLabel("Primeiro número: ");
		rotuloNum1.setHorizontalAlignment(JLabel.RIGHT);
		rotuloNum1.setPreferredSize(new Dimension(200, 30));
		add(rotuloNum1);
		
		// Campo do primeiro número:
		textoNum1 = new JTextField("1");
		textoNum1.setHorizontalAlignment(JTextField.RIGHT);
		textoNum1.setPreferredSize(new Dimension(180, 20));
		add(textoNum1);
		
		// Rótulo do campo do segundo número:
		JLabel rotuloNum2 = new JLabel("Segundo número: ");
		rotuloNum2.setHorizontalAlignment(JLabel.RIGHT);
		rotuloNum2.setPreferredSize(new Dimension(200, 30));
		add(rotuloNum2);
		
		// Campo do segundo número:
		textoNum2 = new JTextField("1");
		textoNum2.setHorizontalAlignment(JTextField.RIGHT);
		textoNum2.setPreferredSize(new Dimension(180, 20));
		add(textoNum2);
		
		// Rótulo do campo do resultado:
		JLabel rotuloMdc = new JLabel("MDC = ");
		rotuloMdc.setHorizontalAlignment(JLabel.RIGHT);
		rotuloMdc.setPreferredSize(new Dimension(200, 50));
		add(rotuloMdc);
		
		// Campo do resultado:
		Font fonte = new Font("Courier", Font.PLAIN, 16);
		textoMdc = new JTextField("1");
		textoMdc.setHorizontalAlignment(JTextField.RIGHT);
		textoMdc.setPreferredSize(new Dimension(180, 20));
		textoMdc.setEditable(false);
		textoMdc.setFont(fonte);
		add(textoMdc);
		
		// Caixas de marcação da fonte usada nos campos de texto:
		checkboxNegrito = new JCheckBox("Negrito");
		checkboxNegrito.setPreferredSize(new Dimension(150, 30));
		add(checkboxNegrito);
		
		checkboxItalico = new JCheckBox("Itálico");
		checkboxItalico.setPreferredSize(new Dimension(150, 30));
		add(checkboxItalico);
		
		// Botão de travar.
		final Icon iconeTravar = new ImageIcon(getClass().getResource("/resources/images/iconLocked.png"));
		final Icon iconeDestravar = new ImageIcon(getClass().getResource("/resources/images/iconUnlocked.png"));
		botaoTravar = new JToggleButton("Travar", iconeTravar);
		add(botaoTravar);
		
		// Botão de saída.
		Icon iconeSair = new ImageIcon(getClass().getResource("/resources/images/iconCancel.png"));
		Icon iconeSairOver = new ImageIcon(getClass().getResource("/resources/images/iconExit.png"));
		JButton botaoSair = new JButton("Sair", iconeSair);
		botaoSair.setRolloverIcon(iconeSairOver);
		add(botaoSair);
		
		// Botão de cálculo.
		Icon iconeMat = new ImageIcon(getClass().getResource("/resources/images/iconMath.png"));
		JButton botaoCalcular = new JButton();
		botaoCalcular.setText("Calcular");
		botaoCalcular.setIcon(iconeMat);
		add(botaoCalcular);
		
		// Registra os ouvintes:
		CalculadoraListener listener = new CalculadoraListener();
		botaoCalcular.addActionListener(listener);
		
		botaoSair.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dispose();
			}
		});
		
		botaoTravar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (botaoTravar.isSelected()) {
					botaoTravar.setText("Destravar");
					botaoTravar.setIcon(iconeDestravar);
				}
				else {
					botaoTravar.setText("Travar");
					botaoTravar.setIcon(iconeTravar);
				}
			}
		});
		
		FonteListener fonteListener = new FonteListener();
		checkboxNegrito.addItemListener(fonteListener);
		checkboxItalico.addItemListener(fonteListener);
		
		// Registra o botão de calcular como default do frame.
		getRootPane().setDefaultButton(botaoCalcular);
	}
	
	private class CalculadoraListener implements ActionListener {
		private Calculadora calc = new Calculadora(); 
		public void actionPerformed(ActionEvent e) {
			if (botaoTravar.isSelected()) {
				JOptionPane.showMessageDialog(null, "Desculpe, a calculadora está travada.", "Calculadora Travada", JOptionPane.WARNING_MESSAGE);
			}
			else {
				String xs = textoNum1.getText();
				String ys = textoNum2.getText();
				
				int x = Integer.parseInt(xs);
				int y = Integer.parseInt(ys);
				int mdc = calc.mdc(x, y);
				
				textoMdc.setText("" + mdc);
			}
		}
	}
	
	private class FonteListener implements ItemListener {
		private int negrito;
		private int italico;
		
		public void itemStateChanged(ItemEvent e) {
			if (e.getSource() == checkboxNegrito) negrito = checkboxNegrito.isSelected() ? Font.BOLD : Font.PLAIN;
			if (e.getSource() == checkboxItalico) italico = checkboxItalico.isSelected() ? Font.ITALIC : Font.PLAIN;
			Font fonte = textoMdc.getFont();
			textoMdc.setFont(fonte.deriveFont(negrito + italico));
		}
	}
}