package parte01;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JToggleButton;
import javax.swing.SwingConstants;

public class MainTesteJPanelLayout {
	public static void main(String[] args) {
		JanelaTesteJPanelLayout janela = new JanelaTesteJPanelLayout("Calculadora Java");
		janela.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		janela.setSize(400, 320);
		janela.setVisible(true);
	}
}

class JanelaTesteJPanelLayout extends JFrame {
	private JTextField textoNum1;
	private JTextField textoNum2;
	private JTextField textoMdc;
	private JToggleButton botaoTravar;
	
	public JanelaTesteJPanelLayout(String titulo) {
		super(titulo);
		initComponents();
	}

	private void initComponents() {
		// Título da janela:
		Icon iconeJar = new ImageIcon(getClass().getResource("/resources/images/iconJar.png"));
		JLabel rotuloTitulo = new JLabel("Calculadora Java", iconeJar, SwingConstants.CENTER);
		rotuloTitulo.setHorizontalTextPosition(JLabel.CENTER);
		rotuloTitulo.setVerticalTextPosition(JLabel.BOTTOM);
		add(rotuloTitulo, BorderLayout.PAGE_START);
		
		// Painel central.
		JPanel painelCentral = new JPanel();
		BoxLayout layoutCentral = new BoxLayout(painelCentral, BoxLayout.PAGE_AXIS);
		painelCentral.setLayout(layoutCentral);
		painelCentral.add(Box.createRigidArea(new Dimension(10, 10)));
		
		// Painel do primeiro número.
		JPanel painelNum1 = new JPanel(new BorderLayout());
		System.out.println(painelNum1.getLayout());
		
		// Rótulo do campo do primeiro número:
		JLabel rotuloNum1 = new JLabel("Primeiro número: ");
		painelNum1.add(rotuloNum1, BorderLayout.LINE_START);
		
		// Campo do primeiro número:
		textoNum1 = new JTextField("1");
		textoNum1.setHorizontalAlignment(JTextField.RIGHT);
		painelNum1.add(textoNum1, BorderLayout.CENTER);
		
		// Adiciona o painel do primeiro número:
		painelCentral.add(painelNum1);
		painelCentral.add(Box.createRigidArea(new Dimension(10, 10)));

		// Painel do segundo número:
		JPanel painelNum2 = new JPanel(new BorderLayout());
		
		// Rótulo do campo do segundo número:
		JLabel rotuloNum2 = new JLabel("Segundo número: ");
		painelNum2.add(rotuloNum2, BorderLayout.LINE_START);
		
		// Campo do segundo número:
		textoNum2 = new JTextField("1");
		textoNum2.setHorizontalAlignment(JTextField.RIGHT);
		painelNum2.add(textoNum2, BorderLayout.CENTER);

		// Adiciona o painel do segundo número:
		painelCentral.add(painelNum2);
		painelCentral.add(Box.createRigidArea(new Dimension(10, 10)));
		
		// Painel do resultado:
		JPanel painelMdc = new JPanel(new BorderLayout());
		
		// Rótulo do campo do resultado:
		JLabel rotuloMdc = new JLabel("MDC = ");
		painelMdc.add(rotuloMdc, BorderLayout.LINE_START);
		
		// Campo do resultado:
		textoMdc = new JTextField("1");
		textoMdc.setHorizontalAlignment(JTextField.RIGHT);
		textoMdc.setEditable(false);
		painelMdc.add(textoMdc, BorderLayout.CENTER);

		// Adiciona o painel do resultado:
		painelCentral.add(painelMdc);
		painelCentral.add(Box.createRigidArea(new Dimension(10, 10)));
		
		// Adiciona o painel central:
		add(painelCentral, BorderLayout.CENTER);

		// Painel de botões:
		JPanel painelBotoes = new JPanel(new FlowLayout(FlowLayout.RIGHT, 5, 0));
		
		// Botão de travar.
		final Icon iconeTravar = new ImageIcon(getClass().getResource("/resources/images/iconLocked.png"));
		final Icon iconeDestravar = new ImageIcon(getClass().getResource("/resources/images/iconUnlocked.png"));
		botaoTravar = new JToggleButton("Travar", iconeTravar);
		painelBotoes.add(botaoTravar);
		
		// Botão de saída.
		Icon iconeSair = new ImageIcon(getClass().getResource("/resources/images/iconCancel.png"));
		Icon iconeSairOver = new ImageIcon(getClass().getResource("/resources/images/iconExit.png"));
		JButton botaoSair = new JButton("Sair", iconeSair);
		botaoSair.setRolloverIcon(iconeSairOver);
		painelBotoes.add(botaoSair);
		
		// Botão de cálculo.
		Icon iconeMat = new ImageIcon(getClass().getResource("/resources/images/iconMath.png"));
		JButton botaoCalcular = new JButton();
		botaoCalcular.setText("Calcular");
		botaoCalcular.setIcon(iconeMat);
		painelBotoes.add(botaoCalcular);

		// Adiciona o painel de botões:
		add(painelBotoes, BorderLayout.PAGE_END);

		// Registra os ouvintes:
		CalculadoraListener listener = new CalculadoraListener();
		botaoCalcular.addActionListener(listener);
		
		botaoSair.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dispose();
			}
		});
		
		botaoTravar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (botaoTravar.isSelected()) {
					botaoTravar.setText("Destravar");
					botaoTravar.setIcon(iconeDestravar);
				}
				else {
					botaoTravar.setText("Travar");
					botaoTravar.setIcon(iconeTravar);
				}
			}
		});
		
		// Registra o botão de calcular como default do frame.
		getRootPane().setDefaultButton(botaoCalcular);
		
		pack();
	}
	
	private class CalculadoraListener implements ActionListener {
		private Calculadora calc = new Calculadora(); 
		public void actionPerformed(ActionEvent e) {
			if (botaoTravar.isSelected()) {
				JOptionPane.showMessageDialog(null, "Desculpe, a calculadora está travada.", "Calculadora Travada", JOptionPane.WARNING_MESSAGE);
			}
			else {
				String xs = textoNum1.getText();
				String ys = textoNum2.getText();
				
				int x = Integer.parseInt(xs);
				int y = Integer.parseInt(ys);
				int mdc = calc.mdc(x, y);
				
				textoMdc.setText("" + mdc);
			}
		}
	}
}